/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"fmt"
)

// TemplateVisibility the model 'TemplateVisibility'
type TemplateVisibility string

// List of TemplateVisibility
const (
	TEMPLATE_VISIBILITY_ADMIN TemplateVisibility = "admin"
	TEMPLATE_VISIBILITY_INBOX TemplateVisibility = "inbox"
)

// All allowed values of TemplateVisibility enum
var AllowedTemplateVisibilityEnumValues = []TemplateVisibility{
	"admin",
	"inbox",
}

func (v *TemplateVisibility) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := TemplateVisibility(value)
	for _, existing := range AllowedTemplateVisibilityEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid TemplateVisibility", value)
}

// NewTemplateVisibilityFromValue returns a pointer to a valid TemplateVisibility
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewTemplateVisibilityFromValue(v string) (*TemplateVisibility, error) {
	ev := TemplateVisibility(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for TemplateVisibility: valid values are %v", v, AllowedTemplateVisibilityEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v TemplateVisibility) IsValid() bool {
	for _, existing := range AllowedTemplateVisibilityEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to TemplateVisibility value
func (v TemplateVisibility) Ptr() *TemplateVisibility {
	return &v
}

type NullableTemplateVisibility struct {
	value *TemplateVisibility
	isSet bool
}

func (v NullableTemplateVisibility) Get() *TemplateVisibility {
	return v.value
}

func (v *NullableTemplateVisibility) Set(val *TemplateVisibility) {
	v.value = val
	v.isSet = true
}

func (v NullableTemplateVisibility) IsSet() bool {
	return v.isSet
}

func (v *NullableTemplateVisibility) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTemplateVisibility(val *TemplateVisibility) *NullableTemplateVisibility {
	return &NullableTemplateVisibility{value: val, isSet: true}
}

func (v NullableTemplateVisibility) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTemplateVisibility) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

